"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.check = void 0;
var interface_1 = require("./interface");
var lodash_1 = __importStar(require("lodash"));
var emoji_regex_1 = __importDefault(require("emoji-regex"));
var fs_1 = __importDefault(require("fs"));
var chalk_1 = __importDefault(require("chalk"));
var check = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    var msgPath, options, notWrite, msg, newMsg, format, emojiList, emoji, emojiPos, transformer, hasFormat, allow, emojiReg, addEmoji, colonIdx, prefix, tail;
    return __generator(this, function (_a) {
        msgPath = opts.msgPath, options = opts.options, notWrite = opts.notWrite;
        if (!msgPath ||
            !fs_1.default.existsSync(msgPath) ||
            fs_1.default.statSync(msgPath).isDirectory()) {
            console.error(chalk_1.default.red("Not found commit msg file path, please check '$1' is passed."));
            return [2 /*return*/, process.exit(1)];
        }
        msg = fs_1.default.readFileSync(msgPath, 'utf-8').trim();
        newMsg = msg;
        format = options.format, emojiList = options.emojiList, emoji = options.emoji, emojiPos = options.emojiPos, transformer = options.transformer;
        hasFormat = (0, lodash_1.isRegExp)(format);
        // check format
        if (hasFormat) {
            allow = format.test(msg);
            if (!allow) {
                console.error("  ".concat(chalk_1.default.bgRed.white(' ERROR '), " ").concat(chalk_1.default.red("invalid commit message format."), "\n\n") +
                    chalk_1.default.red("  Please enter the correct format of the commit msg. Examples:\n\n") +
                    "    ".concat(chalk_1.default.green("feat(bundler-webpack): add 'comments' option"), "\n") +
                    "    ".concat(chalk_1.default.green("fix(core): handle events on blur (close #28)"), "\n"));
                return [2 /*return*/, process.exit(1)];
            }
        }
        // add emoji
        // if not format, unable to find add emoji position
        if (hasFormat && emoji) {
            emojiReg = (0, emoji_regex_1.default)();
            if (!Array.from(msg.matchAll(emojiReg)).length) {
                addEmoji = lodash_1.default.sample(emojiList);
                if (emojiPos === interface_1.EEmojiPos.start) {
                    colonIdx = msg.indexOf(':');
                    prefix = msg.slice(0, colonIdx);
                    tail = msg.slice(colonIdx);
                    newMsg = "".concat(prefix).concat(addEmoji).concat(tail);
                }
                if (emojiPos === interface_1.EEmojiPos.end) {
                    newMsg = "".concat(msg, " ").concat(addEmoji);
                }
                console.log(chalk_1.default.blue("Auto added emoji (".concat(addEmoji, ") to commit msg.")));
            }
        }
        // transform
        if (transformer) {
            newMsg = transformer(newMsg);
        }
        // rewrite
        if (!notWrite && newMsg !== msg) {
            fs_1.default.writeFileSync(msgPath, newMsg, 'utf-8');
        }
        return [2 /*return*/, newMsg];
    });
}); };
exports.check = check;
